import React from 'react';
import dva, { DvaOption } from '{{{ dvaPath }}}';
// @ts-ignore
import createLoading from '{{{ dvaLoadingPath }}}';
import { plugin, PluginType } from 'mdf';

/**
 * @file plugin-dva-app
 */

// 兼容 fundamental
interface AppOpts extends DvaOption {
  rootEl: any;
}

let app: any;
export default function(opts: AppOpts) {
  const config = plugin.invoke({
    key: 'appOpts',
    type: PluginType.modify,
    initValue: {},
  });

  app = dva({
    history,
    ...config,
  });

  app.getAppElement = () => plugin.invoke({
    key: 'appElement',
    type: PluginType.modify,
    initValue: React.createElement(RootElement)
  });

  // loading 插件
  app.use(createLoading());

  // 这里可以注册 modles
  {{{ RegisterModels }}}

  return app;
}

export class RootElement extends React.Component {
  componentWillUnmount() {
    app._models.forEach((model:any) => {
      app.unmodel(model.namespace);
    });
    app._models = [];
    try {
      // 释放 app，for gc，immer 场景 app 是 read-only 的，这里 try catch 一下
      app = null;
    } catch(e) {
      console.error(e);
    }
  }

  render() {
    // 记得要执行 app.router
    return app.start()();
  }
}