"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = _default;

/**
 * @file react 插件集
 */
function _default(api) {
  // 设置 default 无效，因为是在 service 实例化之前读取
  api.describe({
    key: 'framework',
    config: {
      schema(joi) {
        return joi.object({
          type: joi.string().allow('dva', 'fundamental'),
          auth: joi.boolean()
        }).required();
      }

    }
  });

  const _api$getConfig = api.getConfig(),
        framework = _api$getConfig.framework;

  const presets = [require.resolve('./route/route'), require.resolve('./history/history'), require.resolve('./mdf')];

  if (framework.type === 'dva') {
    presets.push(require.resolve('./dva/dva'));
  } else {
    presets.push(require.resolve('./fundamental/fundamental'));
  }

  return {
    presets
  };
}